unit UStructVoiture;

interface

TYPE

    {structure de voiture}
    TCVoiture = class
                {champs de la classe}
                Marque : shortstring;
                Modele : shortstring;
                pFiscale: integer;
                Prix: double;
                {mthode de la classe}
                procedure saisie();
                function  taxe(): double;
                procedure affiche();
                end;


    //************************************************************************
    //!\ la gestion de la liste pourrat tre confie  une autre classe !!! *
    //************************************************************************

    {tableau de voiture}
    TTabVoiture = array of TCVoiture;

    {ajouter une voiture dans la liste}
    procedure addNewVoiture();

    {lister tous les vhicules}
    procedure listeVoiture();

    {lister les vhicules avec une taxe suprieure  ...}
    procedure listeVoitureCritereTaxe(seuil: double);
    
{variable globale, racine de la liste chane}
var globTabVoiture : TTabVoiture;

implementation

var etatMemoire: THeapStatus;

{******************************************}
{******* procdures locales  l'unit *****}
{******************************************}

{librer liste}
procedure libererListe();
var i: integer;
begin
 //vider chaque objet
 for i:= 0 to length(globTabVoiture)-1 do
  globTabVoiture[i].Free();
 //vider le tableau d'objets
 SetLength(globTabVoiture,0);
end;

{******************************************}
{************* mthodes de la classe ******}
{******************************************}

{saisie des paramtres d'une voiture}
procedure TCVoiture.saisie();
begin
 write('Marque : '); readln(Marque);
 write('Modele : '); readln(Modele);
 write('Puissance : '); readln(pFiscale);
 write('Prix : '); readln(Prix);
end;

{afficher les paramtres d'un vhicule}
procedure TCVoiture.affiche();
begin
 write('Marque : '); writeln(Marque);
 write('Modele : '); writeln(Modele);
 write('Puissance : '); writeln(pFiscale);
 write('Prix : '); writeln(Prix);
 write('Taxe : '); writeln(taxe());
end;

{calcul de la taxe associe  un modle}
function TCVoiture.taxe(): double;
begin
 result:= 0.05*Prix+20.0*pFiscale;
end;

{***************************************************}
{*** procdures globales, visibles  l'extrieur ***}
{***************************************************}

{ajouter une voiture dans la liste}
procedure addNewVoiture();
var newV: TCVoiture;
    nb: integer;
begin
 //crer l'objet
 newV:= TCVoiture.Create();
 newV.saisie();
 //l'insrer  la fin du tableau
 nb:= Length(globTabVoiture);
 SetLength(globTabVoiture,nb+1);
 globTabVoiture[nb]:= newV;
end;

{lister tous les vhicules}
procedure listeVoiture();
var i: integer;
begin
 writeln('***************');
 for i:= 0 to Length(globTabVoiture)-1 do
  begin
   globTabVoiture[i].affiche();
   writeln('---------------');
  end;
end;

{lister les vhicules avec une taxe suprieure  ...}
procedure listeVoitureCritereTaxe(seuil: double);
var i: integer;
begin
 writeln('**************');
 for i:= 0 to Length(globTabVoiture)-1 do
  begin
   if (globTabVoiture[i].taxe()>seuil)
    then
     begin
       globTabVoiture[i].affiche();
       writeln('---------------');
     end;
  end;
 writeln('**************');
end;

initialization
 //vrification tat de la mmoire
 etatMemoire:= GetHeapStatus();
 writeln('Memoire allouee en entree = ',etatMemoire.TotalAllocated);
finalization
 //!\ ne pas oublier de librer la liste, sinon catastrophe !
 libererListe();
 //petite vrification de la mmoire
 etatMemoire:= GetHeapStatus();
 writeln('Memoire allouee en sortie = ',etatMemoire.TotalAllocated);
 readln;
end.
