unit UStructVoiture;

interface

TYPE
    {pointeur sur la structure}
    TPtrVoiture = ^TVoiture;

    {structure de voiture}
    TVoiture = record
                {champs de la structure}
                Marque : shortstring;
                Modele : shortstring;
                pFiscale: integer;
                Prix: double;
                {pour construire la liste chane}
                ptrSuivant: TPtrVoiture;
                end;

    {calcul de la taxe associe  un modle}
    function taxeVoiture(v: TVoiture): double;

    {ajouter une voiture dans la liste}
    procedure addNewVoiture();

    {lister tous les vhicules}
    procedure listeVoiture();

    {lister les vhicules avec une taxe suprieure  ...}
    procedure listeVoitureCritereTaxe(seuil: double);

    
{variable globale, racine de la liste chane}
var globPVoiture : TPtrVoiture;

implementation

var etatMemoire: THeapStatus;

{******************************************}
{******* procdures locales  l'unit *****}
{******************************************}

{pointer sur le dernier lment de la liste}
procedure gotoFinListe(var lastPtrVoiture: TPtrVoiture);
begin
 while (lastPtrVoiture^.ptrSuivant<>nil) do
  lastPtrVoiture:= lastPtrVoiture^.ptrSuivant;
end;

{saisie des paramtres d'une voiture}
{ /!\ remarque : si on avait pass le pointeur en paramtres,
il aurait inutile de faire un passage par variable}
procedure saisieVoiture(var v: TVoiture);
begin
 write('Marque : '); readln(v.Marque);
 write('Modele : '); readln(v.Modele);
 write('Puissance : '); readln(v.pFiscale);
 write('Prix : '); readln(v.Prix);
 v.ptrSuivant:= NIL;
end;

{afficher les paramtres d'un vhicule}
procedure affiche(v: TVoiture);
begin
 write('Marque : '); writeln(v.Marque);
 write('Modele : '); writeln(v.Modele);
 write('Puissance : '); writeln(v.pFiscale);
 write('Prix : '); writeln(v.Prix);
 write('Taxe : '); writeln(taxeVoiture(v));
end;

{librer liste}
procedure libererListe();
var suivant: TPtrVoiture;
begin
 while (globPVoiture<>NIL) do
  begin
   //prparer l'accs au suivant
   suivant:= globPVoiture^.ptrSuivant;
   //dtruire l'lment courant
   dispose(globPVoiture);
   //rebrancher sur le suivant
   globPVoiture:= suivant;
  end;
end;

{***************************************************}
{*** procdures globales, visibles  l'extrieur ***}
{***************************************************}

{calcul de la taxe associe  un modle}
function taxeVoiture(v: TVoiture): double;
begin
 result:= 0.05*v.Prix+20.0*v.pFiscale;
end;

{ajouter une voiture dans la liste}
procedure addNewVoiture();
var lastV,newV: TPtrVoiture;
begin
 new(newV);
 saisieVoiture(newV^);
 if (globPVoiture=NIL)
  //si premier cas, l'affecter au premier pointeur
  then globPVoiture:= newV
  //sinon, aller au dernier et ajouter dans la liste
  else
   begin
    lastV:= globPVoiture;
    gotoFinListe(lastV);
    lastV^.ptrSuivant:= newV;
   end;
end;

{lister tous les vhicules}
procedure listeVoiture();
var tmp: TPtrVoiture;
begin
 tmp:= globPVoiture;
 writeln('---------------');
 while (tmp<>NIL) do
  begin
   affiche(tmp^);
   writeln('---------------');
   tmp:= tmp^.PtrSuivant;
  end;
end;

{lister les vhicules avec une taxe suprieure  ...}
procedure listeVoitureCritereTaxe(seuil: double);
var tmp: TPtrVoiture;
begin
 tmp:= globPVoiture;
 writeln('**************');
 while (tmp<>NIL) do
  begin
   if (taxeVoiture(tmp^)>seuil)
    then
     begin
       affiche(tmp^);
       writeln('---------------');
     end;
   tmp:= tmp^.PtrSuivant;
  end;
 writeln('**************');
end;

initialization
 //vrification tat de la mmoire
 etatMemoire:= GetHeapStatus();
 writeln('Memoire allouee en entree = ',etatMemoire.TotalAllocated);
 //mettre le pointeur global  NIL
 globPVoiture:= NIL;
finalization
 //!\ ne pas oublier de librer la liste, sinon catastrophe !
 libererListe();
 //petite vrification de la mmoire
 etatMemoire:= GetHeapStatus();
 writeln('Memoire allouee en sortie = ',etatMemoire.TotalAllocated);
 readln;
end.
