unit UStructVoiture;

interface

TYPE

    {structure de voiture}
    TVoiture = record
                {champs de la structure}
                Marque : shortstring;
                Modele : shortstring;
                pFiscale: integer;
                Prix: double;
                end;

    {tableau de voiture}
    TTabVoiture = array of TVoiture;

    {calcul de la taxe associe  un modle}
    function taxeVoiture(v: TVoiture): double;

    {ajouter une voiture dans la liste}
    procedure addNewVoiture();

    {lister tous les vhicules}
    procedure listeVoiture();

    {lister les vhicules avec une taxe suprieure  ...}
    procedure listeVoitureCritereTaxe(seuil: double);

    
{variable globale, racine de la liste chane}
var globTabVoiture : TTabVoiture;

implementation

var etatMemoire: THeapStatus;

{******************************************}
{******* procdures locales  l'unit *****}
{******************************************}

{saisie des paramtres d'une voiture}
{ /!\ remarque : si on avait pass le pointeur en paramtres,
il aurait inutile de faire un passage par variable}
procedure saisieVoiture(var v: TVoiture);
begin
 write('Marque : '); readln(v.Marque);
 write('Modele : '); readln(v.Modele);
 write('Puissance : '); readln(v.pFiscale);
 write('Prix : '); readln(v.Prix);
end;

{afficher les paramtres d'un vhicule}
procedure affiche(v: TVoiture);
begin
 write('Marque : '); writeln(v.Marque);
 write('Modele : '); writeln(v.Modele);
 write('Puissance : '); writeln(v.pFiscale);
 write('Prix : '); writeln(v.Prix);
 write('Taxe : '); writeln(taxeVoiture(v));
end;

{librer liste}
procedure libererListe();
begin
 SetLength(globTabVoiture,0);
end;

{***************************************************}
{*** procdures globales, visibles  l'extrieur ***}
{***************************************************}

{calcul de la taxe associe  un modle}
function taxeVoiture(v: TVoiture): double;
begin
 result:= 0.05*v.Prix+20.0*v.pFiscale;
end;

{ajouter une voiture dans la liste}
procedure addNewVoiture();
var newV: TVoiture;
    nb: integer;
begin
 saisieVoiture(newV);
 nb:= Length(globTabVoiture);
 SetLength(globTabVoiture,nb+1);
 globTabVoiture[nb]:= newV;
end;

{lister tous les vhicules}
procedure listeVoiture();
var i: integer;
begin
 writeln('***************');
 for i:= 0 to Length(globTabVoiture)-1 do
  begin
   affiche(globTabVoiture[i]);
   writeln('---------------');
  end;
end;

{lister les vhicules avec une taxe suprieure  ...}
procedure listeVoitureCritereTaxe(seuil: double);
var i: integer;
begin
 writeln('**************');
 for i:= 0 to Length(globTabVoiture)-1 do
  begin
   if (taxeVoiture(globTabVoiture[i])>seuil)
    then
     begin
       affiche(globTabVoiture[i]);
       writeln('---------------');
     end;
  end;
 writeln('**************');
end;

initialization
 //vrification tat de la mmoire
 etatMemoire:= GetHeapStatus();
 writeln('Memoire allouee en entree = ',etatMemoire.TotalAllocated);
finalization
 //!\ ne pas oublier de librer la liste, sinon catastrophe !
 libererListe();
 //petite vrification de la mmoire
 etatMemoire:= GetHeapStatus();
 writeln('Memoire allouee en sortie = ',etatMemoire.TotalAllocated);
 readln;
end.
